package web

import (
	"net/http"
	"strconv"
	"subscribe-bot/db"

	"github.com/gin-gonic/gin"
	"github.com/pkg/errors"
)

func (web *Web) mapperIndex(c *gin.Context) (err error) {
	userId := c.Param("userId")
	mapperId, err := strconv.Atoi(userId)
	if err != nil {
		err = errors.Wrap(err, "id is not an integer")
		return
	}

	mapper, err := web.db.GetUser(mapperId)
	if err != nil {
		err = errors.Wrap(err, "failed to get user from mapper-index")
		return
	}

	beatmapsets := make([]db.Beatmapset, 0)
	web.db.IterTrackedBeatmapsetsBy(mapperId, func(beatmapset db.Beatmapset) error {
		beatmapsets = append(beatmapsets, beatmapset)
		return nil
	})

	web.render(c, http.StatusOK, "mapper-index.html", gin.H{
		"Mapper":      mapper,
		"Beatmapsets": beatmapsets,
	})

	return
}
